# pylint: skip-file
import pytest


@pytest.mark.asyncio
async def test_self_link_is_set_on_detail(client):
    response = await client.get('/objects/1')

    assert response.status_code == 200
    dto = response.json()
    assert 'metadata' in dto
    assert 'links' in dto['metadata']
    assert 'self' in dto['metadata']['links']
    assert str.endswith(dto['metadata']['links']['self'], 'objects/1')


@pytest.mark.asyncio
async def test_collection_link_is_set_on_detail(client):
    response = await client.get('/objects/1')

    assert response.status_code == 200
    dto = response.json()
    assert 'metadata' in dto
    assert 'links' in dto['metadata']
    assert 'list' in dto['metadata']['links']

@pytest.mark.asyncio
async def test_children_link_is_set_on_detail(client):
    response = await client.get('/objects/1')

    assert response.status_code == 200
    dto = response.json()
    assert 'metadata' in dto
    assert 'links' in dto['metadata']
    assert 'children' in dto['metadata']['links']
    assert str.endswith(dto['metadata']['links']['children'], 'objects/1/children')


@pytest.mark.asyncio
async def test_collection_link_is_set_on_list(client):
    response = await client.get('/objects')

    assert response.status_code == 200
    dto = response.json()
    assert 'metadata' in dto
    assert 'links' in dto['metadata']
    assert 'self' in dto['metadata']['links']


@pytest.mark.asyncio
async def test_self_link_is_set_on_collection(client):
    response = await client.get('/objects')

    assert response.status_code == 200
    dto = response.json()
    assert 'metadata' in dto
    assert 'links' in dto['metadata']
    assert 'self' in dto['metadata']['links']
    assert str.endswith(dto['metadata']['links']['self'], 'objects')
