import os
import importlib
import inspect
import sys

import cbra

sys.path.append('examples/orderapp')
app = 'orderapp'

collect = [
    ('canon.commands', cbra.Command),
    ('canon.events', cbra.Event),
]


for pkg, cls in collect:
    qualname = f'{app}.{pkg}'
    parent = importlib.import_module(qualname)
    dirname = str.replace(qualname, '.', '/')

    # Import all submodules of the package and generate the __init__.py.
    classes = []
    for fn in os.listdir("examples/orderapp/"+dirname):
        if fn in {'__init__.py', '__pycache__'}:
            continue
        child = importlib.import_module(f"{qualname}.{str.rstrip(fn, '.py')}")
        for attname, member in inspect.getmembers(child):
            if not inspect.isclass(member) or not issubclass(member, cls):
                continue
            classes.append([f"{str.rstrip(fn, '.py')}",member])

    classes = sorted(classes, key=lambda x: x[1].__name__)

    print("# pylint: skip-file")
    for mod, impl in classes:
        print(f"from .{mod} import {impl.__name__}")
    print("")
    print("")
    print("__all__ = [")
    for _, impl in classes:
        print((' ' * 4) + f"'{impl.__name__}'")
    print("]")
