import cbra
import uvicorn

from unimatrix.lib import timezone


app = cbra.Application()


class CurrentTimestamp(cbra.Dependency):

    async def resolve(self) -> int:
        return timezone.now()


@app.get('/')
def example(value: str = CurrentTimestamp()):
    return {
        'timestamp': value
    }


if __name__ == '__main__':
    uvicorn.run(app)
