# pylint: skip-file
import cbra
import fastapi
import uvicorn


app = cbra.Application()

# Of course we can retrieve the URL from the request object in the request
# handler, but this is to demonstrate how parameters are dynamically injected
# into the class constructor.
class ExampleService:

    def __init__(self, request: fastapi.Request):
        self.request = request

    def get_current_url(self):
        return str(self.request.url)


@app.get('/')
def get_dependency(svc: str = cbra.Instance(ExampleService)):
    return {
        "value": svc.get_current_url()
    }


if __name__ == '__main__':
    uvicorn.run(app)
