# pylint: skip-file
import cbra
import ioc


class ExampleQueryRunner(cbra.QueryRunner):

    async def run_example_query(self, query):
        return query.dict()


app = cbra.Application()
app.configure_query_runners({
    'default': ExampleQueryRunner
})


class ExampleQuery(cbra.NamedQuery):
    foo: int

    def build(self, foo: int = cbra.Path(...)):
        return self.model(foo=foo)


@app.get('/{foo:int}')
async def f(obj=ExampleQuery()) -> dict:
    return obj


if __name__ == '__main__':
    import uvicorn

    uvicorn.run(app)
