"""Demonstrates how to create query for request URIs."""
import typing

import cbra
import pydantic
import uvicorn


class ExampleQuery(cbra.query.RequestQuery):
    name: typing.Optional[str] = pydantic.Field(None,
        title="Name",
        description="Filter the search query by the `name` attribute."
    )

    status: typing.List[str] = None


app = cbra.Application()


@app.get('/')
def run_query(query=ExampleQuery(run=False)):
    return query.dict()


if __name__ == '__main__':
    uvicorn.run('__main__:app', reload=True)
