# pylint: skip-file
import cbra
import cbra.ext.webhook


class ExampleWebhook(cbra.ext.webhook.Webhook):
    summary: str = "Example webhook ingest endpoint."

    #: The name of the HTTP request header containing the message signature.
    signature_header: str = 'X-Signature'

    async def handle(self, message: dict):
        # ... do something with message.
        print(message)

    async def get_secret(self, request: cbra.Request, webhook_id: str = None) -> bytes:
        # Return the secret used to verify the signature using HMAC/SHA256.
        return b'secret'


if __name__ == '__main__':
    import uvicorn

    app = cbra.Application()
    app.add(ExampleWebhook(), path='/webhook')
    uvicorn.run(app)
