# pylint: skip-file
import typing

import cbra
import cbra.exceptions
from cbra.ext.oauth2 import RFC9068Principal
from cbra.ext.oauth2.rfc9068principal import Principal


class RFC9068Resource(cbra.Resource):
    principal = RFC9068Principal()

    async def authorize(self):
        if not self.principal.has_scope("read"):
            raise cbra.exceptions.NotAuthorized

    async def retrieve(self) -> typing.Dict[str, str]:
        return {
            "message": "Hello world!"
        }

    class Meta:
        name = 'resource'
        path_parameter: str = 'resource_id'